<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class AfterUpgrade
{
    public function run($container)
    {
        $this->updateUsers($container);

        $config = $container->get('config');

        $languageList = $config->get('languageList', []);
        if (!in_array('fa_IR', $languageList)) {
            $languageList[] = 'fa_IR';
        }
        if (!in_array('lv_LV', $languageList)) {
            $languageList[] = 'lv_LV';
        }
        $config->set('languageList', $languageList);

        $config->save();

        $entityManager = $container->get('entityManager');

        $job = $entityManager->getEntity('Job');
        $dt = new \DateTime();
        $dt->modify('+1 minutes');
        $job->set([
            'serviceName' => 'App',
            'methodName' => 'jobPopulatePhoneNumberNumeric',
            'executeTime' => $dt->format('Y-m-d H:i:s')
        ]);
        $entityManager->saveEntity($job);
    }

    protected function updateUsers($container)
    {
        $entityManager = $container->get('entityManager');

        $pdo = $entityManager->getPDO();

        $sql = "UPDATE `user` SET `type` = 'portal' WHERE `is_portal_user` = 1";
        $pdo->query($sql);

        $sql = "UPDATE `user` SET `type` = 'admin' WHERE `is_admin` = 1";
        $pdo->query($sql);

        $sql = "UPDATE `user` SET `type` = 'super-admin' WHERE `is_super_admin` = 1";
        $pdo->query($sql);

        $sql = "UPDATE `user` SET `type` = 'system' WHERE `id` = 'system'";
        $pdo->query($sql);
    }
}
