<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class BeforeUpgrade
{
    public function run($container)
    {
        $container->get('dataManager');


        $entityManager = $container->get('entityManager');

        $pdo = $container->get('entityManager')->getPdo();

        $pendingJobList = $entityManager->getRepository('Job')->where([
            'status' => 'Pending'
        ])->limit(0, 200)->order('executeTime')->find();

        $trancateJobsSql = "DELETE FROM `job`";
        $pdo->query($trancateJobsSql);

        foreach ($pendingJobList as $job) {
            $data = $job->getValueMap();
            unset($data->id);

            $newJob = $entityManager->getEntity('Job');
            $newJob->set($data);
            $entityManager->saveEntity($newJob);
        }
    }
}
